> For the complete documentation index, see [llms.txt](https://docs.cuoral.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.cuoral.com/api-reference.md).

# API Reference

- [Customers](https://docs.cuoral.com/api-reference/customers.md)
- [Contact](https://docs.cuoral.com/api-reference/customers/contact.md)
- [Get all contacts](https://docs.cuoral.com/api-reference/customers/contact/get-all-contacts.md): Returns a paginated list of customers. Supports filtering, search, and sorting.
- [Bulk Create Customers](https://docs.cuoral.com/api-reference/customers/contact/bulk-create-customers.md): Bulk create customers (up to 100 at a time).
- [Create Customer](https://docs.cuoral.com/api-reference/customers/contact/create-customer.md): Create a new individual customer record
- [Company](https://docs.cuoral.com/api-reference/customers/company.md)
- [Create Company](https://docs.cuoral.com/api-reference/customers/company/create-company.md): Create a new company record associated with a customer base.
- [List Companies](https://docs.cuoral.com/api-reference/customers/company/list-companies.md)
- [Bulk Create Companies](https://docs.cuoral.com/api-reference/customers/company/bulk-create-companies.md): Bulk create companies (up to 50 at a time).
- [Metrics](https://docs.cuoral.com/api-reference/customers/company/metrics.md)
- [Set Company Metric Value](https://docs.cuoral.com/api-reference/customers/company/metrics/set-company-metric-value.md): Set or update a metric value for a specific company.
- [Get Company Metric Values](https://docs.cuoral.com/api-reference/customers/company/metrics/get-company-metric-values.md): Get all metric values recorded for a specific company.
- [Metrics](https://docs.cuoral.com/api-reference/customers/metrics.md)
- [Create Metric Definition](https://docs.cuoral.com/api-reference/customers/metrics/create-metric-definition.md): Create a new metric definition for the organization. This metric can then be assigned values for specific companies.
- [List Metric Definitions](https://docs.cuoral.com/api-reference/customers/metrics/list-metric-definitions.md): List all metric definitions that have been created for the organization.
- [Engagement](https://docs.cuoral.com/api-reference/engagement.md)
- [Whatsapp](https://docs.cuoral.com/api-reference/engagement/whatsapp.md)
- [Send Whatsapp Message](https://docs.cuoral.com/api-reference/engagement/whatsapp/send-whatsapp-message.md): Send standalone plain WhatsApp message
- [Create whatsapp template](https://docs.cuoral.com/api-reference/engagement/whatsapp/create-whatsapp-template.md): Create a WhatsApp template
- [Send template message](https://docs.cuoral.com/api-reference/engagement/whatsapp/send-template-message.md): Send standalone WhatsApp template/content-SID message (e.g., OTP).
- [Get whatsapp templates](https://docs.cuoral.com/api-reference/engagement/whatsapp/get-whatsapp-templates.md): List WhatsApp templates for your organisation.
- [Update whatsapp template](https://docs.cuoral.com/api-reference/engagement/whatsapp/update-whatsapp-template.md): Update a WhatsApp template by SID.
- [Delete whatsapp template](https://docs.cuoral.com/api-reference/engagement/whatsapp/delete-whatsapp-template.md): Delete a WhatsApp template by SID.
- [SMS](https://docs.cuoral.com/api-reference/engagement/sms.md)
- [Sender ID](https://docs.cuoral.com/api-reference/engagement/sms/sender-id.md)
- [Send SMS](https://docs.cuoral.com/api-reference/engagement/sms/send-sms.md): Send an sms to any number
- [Send Bulk SMS](https://docs.cuoral.com/api-reference/engagement/sms/send-bulk-sms.md): Send bulk sms to as many phone number you want at a time
- [Email](https://docs.cuoral.com/api-reference/engagement/email.md)
- [Send Single email](https://docs.cuoral.com/api-reference/engagement/email/send-single-email.md)
- [Send Bulk Email](https://docs.cuoral.com/api-reference/engagement/email/send-bulk-email.md)
- [Churn Intelligence](https://docs.cuoral.com/api-reference/churn-intelligence.md)
- [Events](https://docs.cuoral.com/api-reference/churn-intelligence/events.md)
- [Send custom events](https://docs.cuoral.com/api-reference/churn-intelligence/events/send-custom-events.md): Log and published custom events to the real-time processing pipeline for immediate analysis (health scoring, anomaly detection, abandonment detection).


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.cuoral.com/api-reference.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
